#include <iostream>
#include <bits/stdc++.h>

using namespace std;
typedef long long int ll;
typedef unsigned int uint;
#define STUDENTS 17
#define INF 1234567890

void fill(vector<bool> &valid, int state){
    if (valid[state]) {
        return;
    }
    valid[state] = true;
    for (int i=0; i<STUDENTS; i++){
        fill(valid, state|(1<<i));
    }
}

int main() {
    vector<bool> valid(1 << STUDENTS, false);

    int n;
    cin >> n;
    string s;
    for (int i=0; i<n; i++){
        cin >> s;
        uint club = 0;
        for (char c: s){
            club |= 1 << (c - 'a');
        }
        fill(valid, club);
    }
    string schedule;
    cin >> schedule;
    int m = schedule.size();
    vector<vector<int>> next(m, vector<int>(STUDENTS, INF));
    for (int i=m-2; i>=0; i--) {
        for (int j=0; j<STUDENTS; j++){
            next[i][j] = schedule[i+1] == 'a' + j ? i+1 : next[i+1][j];
        }
    }

    ll result = 0;
    for (int i=0; i<m; i++){
        int j = i;
        uint state = 1 << (schedule[i] - 'a');
        while (j < m && !valid[state]) {
            int closest = INF;
            int closestC = 0;
            for (int k=0; k<STUDENTS; k++){
                if ((state & (1 << k)) == 0 && next[i][k] < closest){
                    closestC = k;
                    closest = next[i][k];
                }
            }
            if (closest != INF){
                state |= 1 << closestC;
            }
            j = closest;
        }
        if (j != INF) {
            //cout << "from position " << i << " end must be " << j << " or later\n";
            result += m - j;
        }
    }

    cout << result << '\n';
    return 0;
}